############################################################################
Summary: CS50 Fall 2010
Name: cs50-2010-fall
Version: 1.0
Release: 2
License: CC BY-NC-SA 3.0
Group: System Environment/Base
Source: %{name}-%{version}-%{release}
Vendor: CS50
URL: https://manual.cs50.net/2010
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires(pre): cs50-appliance
Requires(post): mysql, mysql-server
BuildArch: i386


############################################################################
# ensure RPM is portable by avoiding rpmlib(FileDigests)
# http://lists.rpm.org/pipermail/rpm-list/2009-October/000401.html
%global _binary_filedigest_algorithm 1
%global _source_filedigest_algorithm 1


############################################################################
# ensure RPM is portable by avoiding rpmlib(PayloadIsXz)
# http://www.cmake.org/pipermail/cmake/2010-March/035580.html
%global _binary_payload w9.gzdio


############################################################################
%description
Configures appliance for for Fall 2010.


############################################################################
%prep
/bin/rm -rf %{_builddir}/%{name}-%{version}-%{release}/
/bin/cp -a %{_sourcedir}/%{name}-%{version}-%{release} %{_builddir}/


############################################################################
%install
/bin/rm -rf %{buildroot}
/bin/cp -a %{_builddir}/%{name}-%{version}-%{release} %{buildroot}/


############################################################################
%clean
/bin/rm -rf %{buildroot}


############################################################################
%pre

# /etc/passwd
/usr/sbin/adduser --comment "CS50" --create-home --gid courses --shell /sbin/nologin --system cs50 > /dev/null 2>&1

# return 0
/bin/true


############################################################################
%post

# /home/cs50/
/bin/echo "   Installed CS50's home directory."

# install John Harvard's database for Problem Set 7
/sbin/service mysqld stop > /dev/null 2>&1
/bin/mv /etc/my.cnf /etc/.my.cnf
/bin/cp -a /etc/.my.cnf /etc/my.cnf
/bin/cat > /etc/my.cnf <<"EOF"
[mysqld]
datadir=/var/lib/mysql
skip-grant-tables
skip-networking
socket=/var/lib/mysql/mysql.sock
user=mysql
EOF
/sbin/service mysqld start > /dev/null 2>&1
/usr/bin/mysql --user=root > /dev/null 2>&1 <<"EOF"
CREATE DATABASE IF NOT EXISTS `jharvard_pset7`;
CREATE TABLE IF NOT EXISTS `jharvard_pset7`.`users` (`uid` INT( 11 ) UNSIGNED NOT NULL AUTO_INCREMENT, `username` varchar(255) NOT NULL, `password` varchar(255) NOT NULL, PRIMARY KEY  (`uid`), UNIQUE KEY `username` (`username`)) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=8;
INSERT INTO `jharvard_pset7`.`users` (`uid`, `username`, `password`) VALUES (1, 'guest', 'guest'), (2, 'jcaesar', '13'), (3, 'cpisonis', '13'), (4, 'pskroob', '12345'), (5, 'mscott', 'password'), (6, 'gcostanza', 'Bosco'), (7, 'bvigenere', 'FOOBAR');
EOF
/sbin/service mysqld stop > /dev/null 2>&1
/bin/mv /etc/.my.cnf /etc/my.cnf
/sbin/service mysqld start > /dev/null 2>&1
/bin/echo "   Installed John Harvard's database for Problem Set 7."


############################################################################
%postun

# http://www.redhat.com/archives/rpm-list/2003-August/msg00077.html
# http://www.redhat.com/archives/rpm-list/2005-February/msg00017.html
[ $1 != 0 ] && exit 0

# /etc/passwd
/usr/sbin/userdel --remove cs50 > /dev/null 2>&1

# return 0
/bin/true


############################################################################
%files
%defattr(-,cs50,courses,-)
/home/cs50


############################################################################
%changelog
* Sat Aug 13 2011 David J. Malan <malan@harvard.edu> - 1.0-2
- Changed symlinks in ~cs50/pub/src/lectures/ to actual copies.
- Added "-Werror=unused-but-set-variable" to pset4's Makefile (for getmaxyx's sake).
* Sun Aug 7 2011 David J. Malan <malan@harvard.edu> - 1.0-1
- Initial build
